/* Algoritmul lui Dijkstra
 * Complexitate: O(n * n)
 */ 
#include <fstream>
using namespace std;

ifstream fin("dijkstra.in");
ofstream fout("dijkstra.out");

const int MaxN = 1001, Inf = 0x3f3f3f3f;
int c[MaxN][MaxN]; // matricea ponderilor
int n;  
int S;             // nodul sursa  
int d[MaxN];       // distanta (costul) minim de la nodul sursa
                   // la celelalte noduri
bool s[MaxN];      // retine starea de selectare

void CitesteGraf();
void Dijkstra(int x);
void ScrieDistante();

int main()
{
	CitesteGraf();
	S = 1;       // sursa S = 1;    
	Dijkstra(S); 
	ScrieDistante();
}

void Dijkstra(int x)
{
	for (int j = 1; j <= n; ++j)
		d[j] = c[x][j];
	s[x] = true;  // la primul pas, selectam sursa
	
	for (int pas = 2; pas <= n; ++pas) // O(n^2)
	{
		// cautam nodul x aflat cel mai aproape de sursa
		// in acest moment, dintre nodurile neselectate
		int dmin = Inf; 
		for (int i = 1; i <= n; ++i) // O(n)
			if (!s[i] && d[i] < dmin)
			{
				dmin = d[i];
				x = i;
			}
		
		if (dmin == Inf)
		{
			fout << "Graf neconex!";
			break;
		}	
		// selectam nodul x
		s[x] = true;
		for (int y = 1; y <= n; ++y) // O(n)
			if (d[y] > d[x] + c[x][y])
				d[y] = d[x] + c[x][y];
	}
}

void ScrieDistante()
{
	for (int i = 1; i <=n; ++i)	
		fout << d[i] << ' ';
}

void CitesteGraf()
{
	int x, y, cost;
	fin >> n;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
			if (i != j)
				c[i][j] = Inf;
	
	while (fin >> x >> y >> cost)
	{
		c[x][y] = cost;
		c[y][x] = cost; 
	}
}
